﻿///Szlávi Péter
///ZDOF7J
///szlavip@elte.hu
///
///Feladat: az alábbi alapfogalmak demonstrálása.
///         (Ezekről a fogalmakról beszélgetünk a program kapcsán.)
///         
/// Alapfogalmak:
/// * Load, Paint, Resize eseménykezelők
/// * Alaptípusok: Color
///                Point
/// * Vektor grafikus eszközök: grafikus objektum (Graphics osztály)
///                             Pen
///                             rajzolók (Draw... metódusok)
/// * Rajzolás a Formra: a program induláskor a Paint eseménykezelővel
///                      az ablak átméretezésekor a Resize eseménykezelővel
///                      Refresh metódus
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp_Rajzolas1
{
    struct KétSzínesPont {
        public Point p1;
        public Point p2;
        public Color szín;
        public KétSzínesPont(Point _p1, Point _p2, Color _sz)
        {
            p1 = _p1; p2 = _p2; szín = _sz;
        }
    }

    public partial class frmFo : Form
    {
        KétSzínesPont szakaszVizszintes;
        KétSzínesPont szakaszFüggőleges;
        KétSzínesPont téglalap;
        KétSzínesPont kör;

        public frmFo()
        {
            InitializeComponent();
        }

        private void frmFo_Load(object sender, EventArgs e)
        /**
          * az ablak betöltődése utáni inicializálások:
          * a kirajzolandó kereszt, tégla és kör paramétereinek generálása
          */
        {
            int maxX = this.Width-18;
            int maxY = this.Height-40;
            szakaszVizszintes = new KétSzínesPont(new Point(0, maxY / 2),
                                                  new Point(maxX, maxY / 2),
                                                  Color.Red);
            szakaszFüggőleges = new KétSzínesPont(new Point(maxX / 2, 0),
                                                  new Point(maxX / 2, maxY),
                                                  Color.Red);
            téglalap = new KétSzínesPont(new Point(2, 2)/*bal felső sarok*/, 
                                         new Point(maxX - 4, maxY - 4/*jobb alsó sarok*/), 
                                         Color.Blue);
            kör= new KétSzínesPont(new Point(5, 4)/*bal felső sarok*/,
                                   new Point(maxX - 10, maxY - 8/*jobb alsó sarok*/),
                                   Color.Green);
        }

        private void frmFo_Paint(object sender, PaintEventArgs e)
        {
            MessageBox.Show("Paint esemény");
            Graphics g = e.Graphics;
            //a vízszintes szakasz rajzolása:
            Pen toll = new Pen(szakaszVizszintes.szín);
            g.DrawLine(toll, szakaszVizszintes.p1, szakaszVizszintes.p2);
            //a függőleges szakasz rajzolása:
            toll = new Pen(szakaszFüggőleges.szín);
            g.DrawLine(toll, szakaszFüggőleges.p1, szakaszFüggőleges.p2);
            //a téglalap rajzolása:
            toll = new Pen(téglalap.szín);
            g.DrawRectangle(toll, 
                            téglalap.p1.X, téglalap.p1.Y,
                            téglalap.p2.X, téglalap.p2.Y);
            //a téglalap rajzolása:
            toll = new Pen(kör.szín);
            g.DrawEllipse(toll,
                          kör.p1.X, kör.p1.Y,
                          kör.p2.X, kör.p2.Y);
        }

        private void frmFo_Resize(object sender, EventArgs e)
        {
            frmFo_Load(sender, e);
            Refresh();
        }
    }
}
